from tkinter import * 
from PIL import Image 

def clavier(event):
    global fenetre
    global reponse
    reponse = event.keysym
    print(reponse)
    fenetre.destroy()



def afficher_jeu(Grille):
    global fenetre
    fenetre = Tk()
    largeur=len(Grille[0])
    hauteur=len(Grille)
    taille=20
    num_line=0
    num_case=0
    img = Image.open('mario.gif', 'r')
    x = taille # largeur
    y = taille # hauteur
    img=img.resize((taille,taille))
    img.save('mario_redim.gif')
    mon_mario=PhotoImage(file="mario_redim.gif")
    
    canvas = Canvas(fenetre, width=taille*largeur, height=taille*hauteur, background='white')
    for line in Grille:
        num_line=num_line+1
        for case in line:
            num_case=num_case+1
            if case==0:
                canvas.create_rectangle((num_case-1)*taille, (num_line-1)*taille, num_case*taille, num_line*taille, fill='grey')
            if case==1:
                canvas.create_rectangle((num_case-1)*taille, (num_line-1)*taille, num_case*taille, num_line*taille, fill='black')
            if case==2:
                canvas.create_rectangle((num_case-1)*taille, (num_line-1)*taille, num_case*taille, num_line*taille, fill='white')
            if case==3:
                canvas.create_rectangle((num_case-1)*taille, (num_line-1)*taille, num_case*taille, num_line*taille, fill='red')
            if case==4:
                canvas.create_rectangle((num_case-1)*taille, (num_line-1)*taille, num_case*taille, num_line*taille, fill='blue')
            if case==5:
                canvas.create_image((num_case-1)*taille+taille/2, (num_line-1)*taille+taille/2,image=mon_mario)
                #canvas.create_rectangle((num_case-1)*taille, (num_line-1)*taille, num_case*taille, num_line*taille, fill='pink')
            #else:
                #canvas.create_rectangle((num_case-1)*taille, (num_line-1)*taille, num_case*taille, num_line*taille, fill='white', width=0)
        num_case=0
    canvas.pack()
    canvas.bind_all("<Key>", clavier)
    fenetre.mainloop()




   #############################
   #                           #
   #       Projet SOKOBAN      #
   #                           #
   #############################
   
Grille=[]
ligneSokoban=8
colonneSokoban=11
nb_caisse=6
reponse=""

Grille=[[0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0],
        [0,0,0,0,1,2,2,2,1,0,0,0,0,0,0,0,0,0,0],
        [0,0,0,0,1,3,2,2,1,0,0,0,0,0,0,0,0,0,0],
        [0,0,1,1,1,2,2,3,1,1,0,0,0,0,0,0,0,0,0],
        [0,0,1,2,2,3,2,3,2,1,0,0,0,0,0,0,0,0,0],
        [1,1,1,2,1,2,1,1,2,1,0,0,0,1,1,1,1,1,1],
        [1,2,2,2,1,2,1,1,2,1,1,1,1,1,2,2,2,4,1],
        [1,2,3,2,2,3,2,2,2,2,2,2,2,2,2,2,2,2,1],
        [1,1,1,1,1,2,1,1,1,2,1,5,1,1,2,2,2,2,1],
        [0,0,0,0,1,2,2,2,2,2,1,1,1,1,1,1,1,1,1],
        [0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0]]

def representer(zone):
    """
    procédure permettant d'afficher la représentation
    d'une partie de SOKOBAN codée par zone qui est
    une liste de listes contenant:
    - des 0 : rien
    - des 1 : mur
    - des 2 : emplacement libre
    - des 3 : caisse
    - des 4 : case objectif
    """
    for ligne in zone:
        affichage=""
        for case in ligne:
            if case==0:
                symbole=" "#rien
            elif case==1:
                symbole="M"#mur
            elif case==2:
                symbole=" "#libre
            elif case==3:
                symbole="C"#caisse
            elif case==4:
                symbole="O"#objectif
            elif case==5:
                symbole="S"#sokoban
                
            affichage=affichage+symbole
        print(affichage)
    
def deplacer(direction):
    global Grille
    global ligneSokoban
    global colonneSokoban
    global nb_caisse
    
    if direction=="Z" or direction=="z":
        if Grille[ligneSokoban-1][colonneSokoban]==2:
            Grille[ligneSokoban][colonneSokoban]=2
            ligneSokoban=ligneSokoban-1
            Grille[ligneSokoban][colonneSokoban]=5
        elif Grille[ligneSokoban-1][colonneSokoban]==3:
            if Grille[ligneSokoban-2][colonneSokoban]==2:
                Grille[ligneSokoban][colonneSokoban]=2
                ligneSokoban=ligneSokoban-1
                Grille[ligneSokoban][colonneSokoban]=5
                Grille[ligneSokoban-1][colonneSokoban]=3
            elif Grille[ligneSokoban-2][colonneSokoban]==4:
                Grille[ligneSokoban][colonneSokoban]=2
                ligneSokoban=ligneSokoban-1
                Grille[ligneSokoban][colonneSokoban]=5
                nb_caisse=nb_caisse-1
    #######################################################
    elif direction=="S" or direction=="s":
        if Grille[ligneSokoban+1][colonneSokoban]==2:
            Grille[ligneSokoban][colonneSokoban]=2
            ligneSokoban=ligneSokoban+1
            Grille[ligneSokoban][colonneSokoban]=5
        elif Grille[ligneSokoban+1][colonneSokoban]==3:
            if Grille[ligneSokoban+2][colonneSokoban]==2:
                Grille[ligneSokoban][colonneSokoban]=2
                ligneSokoban=ligneSokoban+1
                Grille[ligneSokoban][colonneSokoban]=5
                Grille[ligneSokoban+1][colonneSokoban]=3
            elif Grille[ligneSokoban+2][colonneSokoban]==4:
                Grille[ligneSokoban][colonneSokoban]=2
                ligneSokoban=ligneSokoban+1
                Grille[ligneSokoban][colonneSokoban]=5
                nb_caisse=nb_caisse-1
    #################################
    elif direction=="D" or direction=="d":
        if Grille[ligneSokoban][colonneSokoban+1]==2:
            Grille[ligneSokoban][colonneSokoban]=2
            colonneSokoban=colonneSokoban+1
            Grille[ligneSokoban][colonneSokoban]=5
        elif Grille[ligneSokoban][colonneSokoban+1]==3:
            if Grille[ligneSokoban][colonneSokoban+2]==2:
                Grille[ligneSokoban][colonneSokoban]=2
                colonneSokoban=colonneSokoban+1
                Grille[ligneSokoban][colonneSokoban]=5
                Grille[ligneSokoban][colonneSokoban+1]=3
            elif Grille[ligneSokoban][colonneSokoban+2]==4:
                Grille[ligneSokoban][colonneSokoban]=2
                colonneSokoban=colonneSokoban+1
                Grille[ligneSokoban][colonneSokoban]=5
                nb_caisse=nb_caisse-1
    #################################
    elif direction=="Q" or direction=="q":
        if Grille[ligneSokoban][colonneSokoban-1]==2:
            Grille[ligneSokoban][colonneSokoban]=2
            colonneSokoban=colonneSokoban-1
            Grille[ligneSokoban][colonneSokoban]=5
        elif Grille[ligneSokoban][colonneSokoban-1]==3:
            if Grille[ligneSokoban][colonneSokoban-2]==2:
                Grille[ligneSokoban][colonneSokoban]=2
                colonneSokoban=colonneSokoban-1
                Grille[ligneSokoban][colonneSokoban]=5
                Grille[ligneSokoban][colonneSokoban-1]=3
            elif Grille[ligneSokoban][colonneSokoban-2]==4:
                Grille[ligneSokoban][colonneSokoban]=2
                colonneSokoban=colonneSokoban-1
                Grille[ligneSokoban][colonneSokoban]=5
                nb_caisse=nb_caisse-1
    #################################

def jouer_Sokoban():
    global Grille
    global ligneSokoban
    global colonneSokoban
    global nb_caisse
    global reponse
    #réinitialisation
    Grille=[]
    ligneSokoban=8
    colonneSokoban=11
    nb_caisse=6
    Grille=[[0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0],
            [0,0,0,0,1,2,2,2,1,0,0,0,0,0,0,0,0,0,0],
            [0,0,0,0,1,3,2,2,1,0,0,0,0,0,0,0,0,0,0],
            [0,0,1,1,1,2,2,3,1,1,0,0,0,0,0,0,0,0,0],
            [0,0,1,2,2,3,2,3,2,1,0,0,0,0,0,0,0,0,0],
            [1,1,1,2,1,2,1,1,2,1,0,0,0,1,1,1,1,1,1],
            [1,2,2,2,1,2,1,1,2,1,1,1,1,1,2,2,2,4,1],
            [1,2,3,2,2,3,2,2,2,2,2,2,2,2,2,2,2,2,1],
            [1,1,1,1,1,2,1,1,1,2,1,5,1,1,2,2,2,2,1],
            [0,0,0,0,1,2,2,2,2,2,1,1,1,1,1,1,1,1,1],
            [0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0]]
    #fin de la réinitialisation
    
    #representer(Grille)
    reponse="nImporteQuoi"
    while reponse!="r" and nb_caisse!=0:
        #reponse=input("Votre déplacement (z/q/s/d) ou r pour recommencer ? ")
        print("Votre déplacement (z/q/s/d) ou r pour recommencer ? ")
        afficher_jeu(Grille)
        deplacer(reponse)


    
    if reponse=="r":
        print("ce n'est pas grave, tu feras mieux la prochaine fois...")
    else :
        print("Bravo !!!")
        
    try_again=input("Voulez vous refaire une partie (y/n - y par défaut)")
    if try_again!="n":
        jouer_Sokoban()
    else :
        print("A bientôt")
        

